\begin{table}[h!]
	\centering
	\caption{Global forwarding engine configuration parameters}
	\vspace{1mm}
	\label{t:global-params}
	\begin{tabular}{||m{0.22\textwidth}|
			>{\centering\arraybackslash}m{0.04\textwidth}|m{0.64\textwidth}||} 
		\hline
		\textbf{name} & \textbf{bits} & \textbf{description} \\ \hline\hline
		
		\texttt{en}               & 1 & forwarding engine enable \\ \hline
		\texttt{tru\_en}          & 1 & topology resolution engine enable \\ \hline
		\texttt{ageing\_bitmap\_ptr} & 1 & currently active aging bitmap pointer \\ \hline
%		\texttt{mr\_ena}          & 1 & port mirroring enable \\ \hline
%		\texttt{prio\_mask}       & TODO & HP priorities mask \\ \hline
%		\texttt{hp\_fw\_cpu\_ena}   & 1 & if 1, recognized HP frames are forwarded to CPU \\ \hline
%		\texttt{urec\_fw\_cpu\_ena} & 1 & if 1, unrecognized frames with \texttt{b\_unrec} set to 1 are 
%		forwarded to CPU \\ \hline
	\end{tabular}
\end{table}

\begin{table}[h!]
	\centering
	\caption{Per port forwarding engine configuration parameters.}
	\vspace{1mm}
	\label{t:port-params}
	\begin{tabular}{||m{0.22\textwidth}|
			>{\centering\arraybackslash}m{0.04\textwidth}|m{0.64\textwidth}||} 
		\hline
		\textbf{name} & \textbf{bits} & \textbf{description} \\ \hline\hline
		
		\texttt{learn\_en}  & 1 & learning enable \\ \hline
		\texttt{pass\_all}  & 1 & pass all frames \\ \hline
		\texttt{pass\_local\_link} & 1 & pass frames with link-local destination MAC address \\ \hline
%		\texttt{fix\_prio}  & 1 & if 1, override frame's priority with prio \\ \hline
%		\texttt{prio}       & 4 & priority of the frame \\ \hline
		\texttt{b\_unrec}   & 1 & if 1, unrecognized requests are broadcasted; if 0, unrecognized requests are dropped \\ \hline
	\end{tabular}
\end{table}

\begin{table}[h!]
	\centering
	\caption{Learning FIFO entry data set.}
	\vspace{1mm}
	\label{t:learning-fifo}
	\begin{tabular}{||m{0.22\textwidth}|>{\centering\arraybackslash}m{0.04\textwidth}|m{0.64\textwidth}||} 
		\hline
		\textbf{name} & \textbf{bits} & \textbf{description} \\ \hline\hline
		
		\texttt{pid}       & 6  & port ID \\ \hline
		\texttt{smac}      & 48 & source MAC address \\ \hline
		\texttt{vid}       & 12 & VLAN ID \\ \hline
		\texttt{has\_vid}  & 1  & validates \texttt{vid} \\ \hline
		\texttt{prio}      & 8  & priority of the frame \\ \hline
		\texttt{has\_prio} & 1  & validates \texttt{prio} \\ \hline
	\end{tabular}
\end{table}

\begin{table}[h!]
	\centering
	\caption{Forwarding engine request data set.}
	\vspace{1mm}
	\label{t:request}
	\begin{tabular}{||m{0.22\textwidth}|>{\centering\arraybackslash}m{0.04\textwidth}|m{0.64\textwidth}||} 
		\hline
		\textbf{name} & \textbf{bits} & \textbf{description} \\ \hline\hline
		
		\texttt{id}        & 8  & frame ID \\ \hline
		\texttt{smac}      & 48 & source MAC address \\ \hline
		\texttt{dmac}      & 48 & destination MAC address \\ \hline
		\texttt{vid}       & 12 & VLAN ID \\ \hline
		\texttt{has\_vid}  & 1  & validates \texttt{vid} \\ \hline
		\texttt{prio}      & 8  & priority of the frame \\ \hline
		\texttt{has\_prio} & 1  & validates \texttt{prio} \\ \hline	
	\end{tabular}
\end{table}

\begin{table}[h!]
	\centering
	\caption{Forwarding engine response data set.}
	\vspace{1mm}
	\label{t:response}
	\begin{tabular}{||m{0.22\textwidth}|>{\centering\arraybackslash}m{0.04\textwidth}|m{0.64\textwidth}||} 
		\hline
		\textbf{name} & \textbf{bits} & \textbf{description} \\ \hline\hline
		
		\texttt{id}         & 8  & frame ID \\ \hline
		\texttt{port\_mask} & 24 & port mask, final forwarding decision \\ \hline
		\texttt{prio}       & 8  & priority of the frame \\ \hline
		\texttt{drop}       & 1  & if 1, drop frame \\ \hline
		\texttt{hp}         & 1  & if 1, frame has a high priority \\ \hline
	\end{tabular}
\end{table}

\begin{table}[h!]
	\centering
	\caption{TRU module request data set.}
	\vspace{1mm}
	\label{tru:request}
	\begin{tabular}{||m{0.22\textwidth}|>{\centering\arraybackslash}m{0.04\textwidth}|m{0.64\textwidth}||} 
		\hline
		\textbf{name} & \textbf{bits} & \textbf{description} \\ \hline\hline
		
		\texttt{smac}      & 48 & source MAC address \\ \hline
		\texttt{dmac}      & 48 & destination MAC address \\ \hline
		\texttt{fid}       &  8 & Filtering ID \\ \hline
		\texttt{is\_hp}    &  1 & high priority flag \\ \hline
		\texttt{is\_br}    &  1 & broadcast frame flag \\ \hline
		\texttt{req\_mask} & 24 & mask indicating requesting port \\ \hline
		\texttt{prio}      &  3 & priority of the frame \\ \hline
	\end{tabular}
\end{table}

\begin{table}[h!]
	\centering
	\caption{TRU module response data set.}
	\vspace{1mm}
	\label{tru:response}
	\begin{tabular}{||m{0.22\textwidth}|>{\centering\arraybackslash}m{0.04\textwidth}|m{0.64\textwidth}||} 
		\hline
		\textbf{name} & \textbf{bits} & \textbf{description} \\ \hline\hline
		
		\texttt{port\_mask} & 24 & mask with 1's at forward ports \\ \hline
		\texttt{drop}       &  1 & if 1, drop the frame \\ \hline
		\texttt{resp\_mask} & 24 & mask with 1 at requesting port \\ \hline
	\end{tabular}
\end{table}